
Redmine - Defect #38286

"Cannot delete enumeration" error may occur when attempting to delete a project with time entries

2023-02-21 06:28 - naoki takaesu

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Projects Estimated time: 0.00 hour

Target version: 5.0.6   

Resolution: Fixed Affected version: 5.0.4

Description

Steps to reproduce

1. Create Project

2. Settings > Time tracking

1. uncheck item -> save

2. check item -> save (System Activity was unchecked)

3. Click "Spent time" tab

1. create new log time. (select activity on above item)

4. Settings > Time tracking

1. uncheck item -> save

5. Delete project

It is displayed 500 internal server error.

(raise "Cannot delete enumeration")

Related issues:

Related to Redmine - Patch #36416: Cleanup more dependent objects on project ... Closed

Has duplicate Redmine - Patch #38645: RuntimeError when calling Project#destr... Closed

Associated revisions

Revision 22155 - 2023-03-25 06:09 - Go MAEDA

"Cannot delete enumeration" error may occur when attempting to delete a project with time entries (#38286).

Patch by Holger Just and Mizuki ISHIKAWA.

Revision 22157 - 2023-03-26 00:50 - Go MAEDA

Merged r22155 from trunk to 5.0-stable (#38286).

History

#1 - 2023-02-23 20:22 - Holger Just

When destroying a project, Redmine recursively destroys all related objects.

In this case however, it tries to first destroy the (project-local) time entry activities before it destroys the time entries using those activities. Since

destroying an activity is only possible when there are no time entries using it, the project destroy may fail in this case.

I believe this may be solved by making sure that during a project destroy, Redmine first destroys the time entries and only then the activities.

I haven't yet fully tested it, but this issue might be solved with a patch like this where we move the declaration of the related time_entry_activities

below the declaration of the time_entries:

--- a/app/models/project.rb

+++ b/app/models/project.rb

@@ -30,8 +30,6 @@ class Project < ActiveRecord::Base

   # Maximum length for project identifiers

   IDENTIFIER_MAX_LENGTH = 100

-  # Specific overridden Activities

-  has_many :time_entry_activities, :dependent => :destroy

   has_many :memberships, :class_name => 'Member', :inverse_of => :project

   # Memberships of active users only

   has_many :members,
@@ -44,6 +42,8 @@ class Project < ActiveRecord::Base

   belongs_to :default_version, :class_name => 'Version'

   belongs_to :default_assigned_to, :class_name => 'Principal'

   has_many :time_entries, :dependent => :destroy

+  # Specific overridden Activities

+  has_many :time_entry_activities, :dependent => :destroy

   has_many :queries, :dependent => :destroy

   has_many :documents, :dependent => :destroy

   has_many :news, lambda {includes(:author)}, :dependent => :destroy

#2 - 2023-02-23 20:59 - Holger Just

- Status changed from New to Confirmed

#3 - 2023-03-01 15:13 - Go MAEDA

- Related to Patch #36416: Cleanup more dependent objects on project delete added

#4 - 2023-03-02 05:04 - Go MAEDA

- Target version set to Candidate for next minor release

#5 - 2023-03-02 09:38 - Mizuki ISHIKAWA

If you change the test code as follows, you will see that the test fails before the #38286#note-1 change and succeeds after the change.

diff --git a/test/unit/project_test.rb b/test/unit/project_test.rb

index 3e478e66ee..a27da8f9de 100644

--- a/test/unit/project_test.rb

+++ b/test/unit/project_test.rb

@@ -236,6 +236,7 @@ class ProjectTest < ActiveSupport::TestCase

     # generate some dependent objects

     overridden_activity = TimeEntryActivity.new({:name => "Project", :project => @ecookbook})

     assert overridden_activity.save!

+    TimeEntry.generate!(:project => @ecookbook, :activity_id => overridden_activity.id)

     query = IssueQuery.generate!(:project => @ecookbook, :visibility => Query::VISIBILITY_ROLES, :roles => Ro

le.where(:id => [1, 3]).to_a)

#6 - 2023-03-13 03:40 - Go MAEDA

- Target version changed from Candidate for next minor release to 5.0.6

Setting the target version to 5.0.6.

#7 - 2023-03-25 06:10 - Go MAEDA

- Status changed from Confirmed to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix. Thank you.

#8 - 2023-03-26 00:50 - Go MAEDA

- Subject changed from Cannot delete project (raise "Cannot delete enumeration") to "Cannot delete enumeration" error may occur when attempting to

delete a project with time entries

- Status changed from Resolved to Closed

#9 - 2023-06-02 07:15 - Go MAEDA

- Has duplicate Patch #38645: RuntimeError when calling Project#destroy with overridden activity time entry added

Powered by TCPDF (www.tcpdf.org)

2024-03-13 2/2

https://www.redmine.org/issues/38286#note-1
http://www.tcpdf.org

